clsf <-
function(test.sample, b.ct, sp.ct, s0,si, prior) {
  used <- b.ct - sp.ct != 0

  # seems sometimes NAs are introduced if exponent are not limited
  sfe <- function(x) {
    xx <- sign(x) * pmin(abs(x), 600)
    return(exp(xx))
  }
  
  if (length(test.sample)==length(used)) {
  
    b.dk <- sum(((test.sample[used] - (b.ct[used] ))^2) / (si[used]+s0)^2)  - 2 *log2( prior )
    sp.dk <- sum(((test.sample[used] - (sp.ct[used] ))^2) / (si[used]+s0)^2)  - 2 *log2( prior )
  
    # thanks to Gergana Bounova for rewriting the eqution for probabilities:
    b.pr = 1 / ( 1 + exp( 0.5 * (b.dk - sp.dk)))
    s.pr = 1 / ( 1 + exp( 0.5 * (sp.dk - b.dk)))


  if (is.na(b.pr)) {
    return('input data is likely out of range')
    } else {
    return(b.pr)
    }
  } else {
  print('sample length does not equal platform length')
  }
}
