\name{example.ratios}
\alias{example.ratios}
\docType{data}
\title{
Example log ratios from 6 tumors.
}
\description{
Array Comparative Genomic Hybridization log ratios of 6 tumors. 
}
\usage{data("example.ratios")}
\format{
  A data frame with 3277 observations on the following 13 variables.
  \describe{
    \item{\code{chrom}}{a numeric vector}
    \item{\code{maploc}}{a numeric vector}
    \item{\code{example1}}{a numeric vector}
    \item{\code{example2}}{a numeric vector}
    \item{\code{example3}}{a numeric vector}
    \item{\code{example4}}{a numeric vector}
    \item{\code{example5}}{a numeric vector}
    \item{\code{example6}}{a numeric vector}
  }
}
\details{
chrom: hg18 chromosome
maploc: chromosomal midposition of the BAC clone
example1: log ratios from example tumor
example2: log ratios from example tumor
example3: log ratios from example tumor
example4: log ratios from example tumor
example5: log ratios from example tumor
example6: log ratios from example tumor
}

\examples{
head(example.ratios)
}
\keyword{datasets}
