\name{example.segments}
\alias{example.segments}
\docType{data}
\title{
Example segmented log ratios from 6 tumors.
}
\description{
Array Comparative Genomic Hybridization segmented log ratios of 6 tumors. 
}
\usage{data("example.segments")}
\format{
  A data frame with 3277 observations on the following 13 variables.
  \describe{
    \item{\code{chrom}}{a numeric vector}
    \item{\code{maploc}}{a numeric vector}
    \item{\code{example1}}{a numeric vector}
    \item{\code{example2}}{a numeric vector}
    \item{\code{example3}}{a numeric vector}
    \item{\code{example4}}{a numeric vector}
    \item{\code{example5}}{a numeric vector}
    \item{\code{example6}}{a numeric vector}
  }
}
\details{
chrom: hg18 chromosome
maploc: chromosomal midposition of the BAC clone
example1: segmented log ratios from example tumor
example2: segmented log ratios from example tumor
example3: segmented log ratios from example tumor
example4: segmented log ratios from example tumor
example5: segmented log ratios from example tumor
example6: segmented log ratios from example tumor
}

\examples{
head(example.segments)
}
\keyword{datasets}
